using System;
using System.Text;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Text.RegularExpressions;
using QuartzTypeLib;

namespace SubFutzer
{
	/// <summary>
	/// Summary description for SubFutzerForm.
	/// </summary>
	public class SubFutzerForm : System.Windows.Forms.Form
	{
        private System.Windows.Forms.MainMenu mainMenu1;
        private System.Windows.Forms.MenuItem menuItem10;
        private System.Windows.Forms.ColumnHeader chIndex;
        private System.Windows.Forms.ColumnHeader chStartTime;
        private System.Windows.Forms.ColumnHeader chStopTime;
        private System.Windows.Forms.ColumnHeader chDuration;
        private System.Windows.Forms.ColumnHeader chText;
        private System.Windows.Forms.MenuItem mi_File_New;
        private System.Windows.Forms.MenuItem mi_File_Open;
        private System.Windows.Forms.MenuItem mi_File_Close;
        private System.Windows.Forms.MenuItem mi_File_Save;
        private System.Windows.Forms.MenuItem mi_File_SaveAs;
        private System.Windows.Forms.MenuItem mi_File_Exit;
        private System.Windows.Forms.OpenFileDialog openFileDialog1;
        private System.Windows.Forms.SaveFileDialog saveFileDialog1;
        public System.Windows.Forms.ListView lvSubtitles;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

        private bool m_bDirty = false;
        public System.Windows.Forms.StatusBar statusBar1;
        private System.Windows.Forms.Splitter splitter1;
        private System.Windows.Forms.MenuItem mi_File;
        private System.Windows.Forms.MenuItem mi_Edit;
        private System.Windows.Forms.Splitter splitter2;
        private System.Windows.Forms.Panel panel1;
        private System.Windows.Forms.Label label1;
        private System.Windows.Forms.Label label2;
        private SubFutzer.TimeTextBox ttbStart;
        private SubFutzer.TimeTextBox ttbStop;
        private System.Windows.Forms.Label label3;
        public System.Windows.Forms.TextBox tbSubtitle;
        private string m_sFileName;
        private System.Windows.Forms.Panel panelControls;
        private SubFutzer.TimeTextBox ttbOffset;
        private System.Windows.Forms.ComboBox cbWhatAction;
        private System.Windows.Forms.ComboBox cbWhichItems;
        private System.Windows.Forms.Button btnChange;
        private System.Windows.Forms.Button btnUpdate;
        private System.Windows.Forms.CheckBox checkLockTimes;
        private System.Windows.Forms.MenuItem mi_Edit_Options;

        private bool m_bInitialized;
        private System.Windows.Forms.MenuItem mi_Action;
        private System.Windows.Forms.MenuItem mi_Action_ProcessJobs;
        private System.Windows.Forms.MenuItem mi_Action_ProcessDefault;
        private System.Windows.Forms.OpenFileDialog openFileDialog2;
        private System.Windows.Forms.Label label4;
        private System.Windows.Forms.Button btnSetMaxLength;
        private System.Windows.Forms.Button btnMergeAll;
        private System.Windows.Forms.TextBox tbMaxLength;
        private System.Windows.Forms.MenuItem menuItem1;
        private System.Windows.Forms.MenuItem mi_Action_Renumber;
        private System.Windows.Forms.ContextMenu cmListBox;
        private System.Windows.Forms.MenuItem mi_Context_DeleteSelected;
        private System.Windows.Forms.MenuItem mi_Context_DeleteExcept;
        private System.Windows.Forms.MenuItem menuItem3;
        private System.Windows.Forms.MenuItem mi_Edit_Undo;
        public SFOptions m_options = new SFOptions();

        private ArrayList alUndoData = new ArrayList();
        private System.Windows.Forms.MenuItem mi_File_Merge;
        private System.Windows.Forms.CheckBox checkNLBeforeBracket;
        private System.Windows.Forms.GroupBox groupBox1;
        private System.Windows.Forms.Label label5;
        private System.Windows.Forms.MenuItem mi_Help;
        private System.Windows.Forms.MenuItem mi_Help_About;
        private System.Windows.Forms.HelpProvider helpProvider1;
        private System.Windows.Forms.MenuItem mi_Edit_Find;
        private ArrayList alRedoData = new ArrayList();
        private System.Windows.Forms.MenuItem miMRUSeparator;

        private SFFindText dlgFindText = new SFFindText();
        private System.Windows.Forms.MenuItem mi_Edit_FindAgain;
        private System.Windows.Forms.MenuItem mi_Action_Collapse;
        private System.Windows.Forms.MenuItem menuItem2;
        private System.Windows.Forms.MenuItem mi_Edit_Next;
        private System.Windows.Forms.MenuItem mi_Edit_Previous;
        private System.Windows.Forms.MenuItem mi_Context_Merge;
		private System.Windows.Forms.MenuItem mi_Edit_GoTo;
		private System.Windows.Forms.MenuItem mi_Action_RemoveShort;
		private System.Windows.Forms.MenuItem mi_Action_RemoveIntra;
        private System.Windows.Forms.MenuItem menuItem4;
        private System.Windows.Forms.MenuItem mi_Action_SubDown;
        private System.Windows.Forms.MenuItem mi_Action_SubUp;
        private System.Windows.Forms.MenuItem menuItem5;
        private System.Windows.Forms.MenuItem mi_Context_Insert;
        private MenuItem m_MRUStart = null;

        private CommandProcessor m_cmdProc = null;

        public SubFutzerForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

            lvSubtitles.FullRowSelect = true;
            cbWhichItems.SelectedIndex = 0;
            cbWhatAction.SelectedIndex = 0;
            m_bInitialized = true;
            checkLockTimes.Checked = true;
            tbMaxLength.Text = m_options.iLineLength.ToString();
            dlgFindText.ShowInTaskbar = false;
            dlgFindText.SetMainForm(this);
            dlgFindText.Visible = false;
            dlgFindText.CreateControl();
            dlgFindText.DesktopLocation = new Point(0,0);
            CreateMRUList();

            m_cmdProc = new CommandProcessor(this);

            ProcessArgs();

            m_cmdProc.Run();
		}

        enum NextArg { None, CommandFile };

        private void ProcessArgs()
        {
            NextArg nextArg = NextArg.None;

            foreach(string sArg in Environment.GetCommandLineArgs())
            {
                switch(nextArg)
                {
                    case NextArg.None:
                        if (sArg[0] == '-')
                        {
                            foreach(char c in sArg.Substring(1))
                            {
                                switch(c)
                                {
                                    case 'f':
                                    case 'F':
                                        nextArg = NextArg.CommandFile;
                                        break;
                                    default:
                                        break;
                                }
                            }
                        }
                        else
                        {
                            // Unknown argument, or our own executable name (arg 0)
                        }
                        break;
                    case NextArg.CommandFile:
                        m_cmdProc.SetFile(sArg);
                        nextArg = NextArg.None;
                        break;
                }
            }
        }

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.lvSubtitles = new System.Windows.Forms.ListView();
			this.chIndex = new System.Windows.Forms.ColumnHeader();
			this.chStartTime = new System.Windows.Forms.ColumnHeader();
			this.chStopTime = new System.Windows.Forms.ColumnHeader();
			this.chDuration = new System.Windows.Forms.ColumnHeader();
			this.chText = new System.Windows.Forms.ColumnHeader();
			this.cmListBox = new System.Windows.Forms.ContextMenu();
			this.mi_Context_DeleteSelected = new System.Windows.Forms.MenuItem();
			this.mi_Context_DeleteExcept = new System.Windows.Forms.MenuItem();
			this.mi_Context_Merge = new System.Windows.Forms.MenuItem();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.mi_Context_Insert = new System.Windows.Forms.MenuItem();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.mi_File = new System.Windows.Forms.MenuItem();
			this.mi_File_New = new System.Windows.Forms.MenuItem();
			this.mi_File_Open = new System.Windows.Forms.MenuItem();
			this.mi_File_Merge = new System.Windows.Forms.MenuItem();
			this.mi_File_Close = new System.Windows.Forms.MenuItem();
			this.menuItem10 = new System.Windows.Forms.MenuItem();
			this.mi_File_Save = new System.Windows.Forms.MenuItem();
			this.mi_File_SaveAs = new System.Windows.Forms.MenuItem();
			this.miMRUSeparator = new System.Windows.Forms.MenuItem();
			this.mi_File_Exit = new System.Windows.Forms.MenuItem();
			this.mi_Edit = new System.Windows.Forms.MenuItem();
			this.mi_Edit_Undo = new System.Windows.Forms.MenuItem();
			this.mi_Edit_Find = new System.Windows.Forms.MenuItem();
			this.mi_Edit_FindAgain = new System.Windows.Forms.MenuItem();
			this.mi_Edit_GoTo = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.mi_Edit_Options = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.mi_Edit_Next = new System.Windows.Forms.MenuItem();
			this.mi_Edit_Previous = new System.Windows.Forms.MenuItem();
			this.mi_Action = new System.Windows.Forms.MenuItem();
			this.mi_Action_Renumber = new System.Windows.Forms.MenuItem();
			this.mi_Action_Collapse = new System.Windows.Forms.MenuItem();
			this.mi_Action_RemoveShort = new System.Windows.Forms.MenuItem();
			this.mi_Action_RemoveIntra = new System.Windows.Forms.MenuItem();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.mi_Action_SubDown = new System.Windows.Forms.MenuItem();
			this.mi_Action_SubUp = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.mi_Action_ProcessJobs = new System.Windows.Forms.MenuItem();
			this.mi_Action_ProcessDefault = new System.Windows.Forms.MenuItem();
			this.mi_Help = new System.Windows.Forms.MenuItem();
			this.mi_Help_About = new System.Windows.Forms.MenuItem();
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			this.statusBar1 = new System.Windows.Forms.StatusBar();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.panelControls = new System.Windows.Forms.Panel();
			this.cbWhichItems = new System.Windows.Forms.ComboBox();
			this.label5 = new System.Windows.Forms.Label();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.tbMaxLength = new System.Windows.Forms.TextBox();
			this.label4 = new System.Windows.Forms.Label();
			this.btnSetMaxLength = new System.Windows.Forms.Button();
			this.ttbOffset = new SubFutzer.TimeTextBox();
			this.cbWhatAction = new System.Windows.Forms.ComboBox();
			this.checkNLBeforeBracket = new System.Windows.Forms.CheckBox();
			this.btnChange = new System.Windows.Forms.Button();
			this.btnMergeAll = new System.Windows.Forms.Button();
			this.checkLockTimes = new System.Windows.Forms.CheckBox();
			this.btnUpdate = new System.Windows.Forms.Button();
			this.tbSubtitle = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.ttbStart = new SubFutzer.TimeTextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.ttbStop = new SubFutzer.TimeTextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.splitter2 = new System.Windows.Forms.Splitter();
			this.panel1 = new System.Windows.Forms.Panel();
			this.openFileDialog2 = new System.Windows.Forms.OpenFileDialog();
			this.helpProvider1 = new System.Windows.Forms.HelpProvider();
			this.panelControls.SuspendLayout();
			this.groupBox1.SuspendLayout();
			this.panel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// lvSubtitles
			// 
			this.lvSubtitles.AllowDrop = true;
			this.lvSubtitles.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						  this.chIndex,
																						  this.chStartTime,
																						  this.chStopTime,
																						  this.chDuration,
																						  this.chText});
			this.lvSubtitles.ContextMenu = this.cmListBox;
			this.lvSubtitles.Dock = System.Windows.Forms.DockStyle.Fill;
			this.helpProvider1.SetHelpString(this.lvSubtitles, "This list view contains the set of indexed subtitles.  Subtitles here can be dele" +
				"ted or cropped through the context menu.  To edit the attributes of an individua" +
				"l subtitle, use the controls below.");
			this.lvSubtitles.HideSelection = false;
			this.lvSubtitles.Location = new System.Drawing.Point(0, 0);
			this.lvSubtitles.Name = "lvSubtitles";
			this.helpProvider1.SetShowHelp(this.lvSubtitles, true);
			this.lvSubtitles.Size = new System.Drawing.Size(656, 211);
			this.lvSubtitles.TabIndex = 0;
			this.lvSubtitles.View = System.Windows.Forms.View.Details;
			this.lvSubtitles.KeyDown += new System.Windows.Forms.KeyEventHandler(this.SubFutzerForm_KeyDown);
			this.lvSubtitles.DragDrop += new System.Windows.Forms.DragEventHandler(this.lvSubtitles_DragDrop);
			this.lvSubtitles.DragEnter += new System.Windows.Forms.DragEventHandler(this.lvSubtitles_DragEnter);
			this.lvSubtitles.SelectedIndexChanged += new System.EventHandler(this.lvSubtitles_SelectedIndexChanged);
			// 
			// chIndex
			// 
			this.chIndex.Text = "Index";
			this.chIndex.Width = 50;
			// 
			// chStartTime
			// 
			this.chStartTime.Text = "Start";
			// 
			// chStopTime
			// 
			this.chStopTime.Text = "Stop";
			// 
			// chDuration
			// 
			this.chDuration.Text = "Duration";
			// 
			// chText
			// 
			this.chText.Text = "Subtitle Text";
			this.chText.Width = 400;
			// 
			// cmListBox
			// 
			this.cmListBox.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.mi_Context_DeleteSelected,
																					  this.mi_Context_DeleteExcept,
																					  this.mi_Context_Merge,
																					  this.menuItem5,
																					  this.mi_Context_Insert});
			// 
			// mi_Context_DeleteSelected
			// 
			this.mi_Context_DeleteSelected.Index = 0;
			this.mi_Context_DeleteSelected.Text = "&Delete selected items";
			this.mi_Context_DeleteSelected.Click += new System.EventHandler(this.mi_Context_DeleteSelected_Click);
			// 
			// mi_Context_DeleteExcept
			// 
			this.mi_Context_DeleteExcept.Index = 1;
			this.mi_Context_DeleteExcept.Text = "Delete all &except selected";
			this.mi_Context_DeleteExcept.Click += new System.EventHandler(this.mi_Context_DeleteExcept_Click);
			// 
			// mi_Context_Merge
			// 
			this.mi_Context_Merge.Index = 2;
			this.mi_Context_Merge.Text = "&Merge items into single subtitle";
			this.mi_Context_Merge.Click += new System.EventHandler(this.mi_Context_Merge_Click);
			// 
			// menuItem5
			// 
			this.menuItem5.Index = 3;
			this.menuItem5.Text = "-";
			// 
			// mi_Context_Insert
			// 
			this.mi_Context_Insert.Index = 4;
			this.mi_Context_Insert.Text = "&Insert Subtitle";
			this.mi_Context_Insert.Click += new System.EventHandler(this.mi_Context_Insert_Click);
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.mi_File,
																					  this.mi_Edit,
																					  this.mi_Action,
																					  this.mi_Help});
			// 
			// mi_File
			// 
			this.mi_File.Index = 0;
			this.mi_File.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.mi_File_New,
																					this.mi_File_Open,
																					this.mi_File_Merge,
																					this.mi_File_Close,
																					this.menuItem10,
																					this.mi_File_Save,
																					this.mi_File_SaveAs,
																					this.miMRUSeparator,
																					this.mi_File_Exit});
			this.mi_File.Text = "&File";
			this.mi_File.Popup += new System.EventHandler(this.mi_File_Popup);
			// 
			// mi_File_New
			// 
			this.mi_File_New.Index = 0;
			this.mi_File_New.Text = "&New";
			this.mi_File_New.Click += new System.EventHandler(this.mi_File_New_Click);
			this.mi_File_New.Select += new System.EventHandler(this.mi_File_New_Select);
			// 
			// mi_File_Open
			// 
			this.mi_File_Open.Index = 1;
			this.mi_File_Open.Shortcut = System.Windows.Forms.Shortcut.CtrlO;
			this.mi_File_Open.Text = "&Open...";
			this.mi_File_Open.Click += new System.EventHandler(this.mi_File_Open_Click);
			this.mi_File_Open.Select += new System.EventHandler(this.mi_File_Open_Select);
			// 
			// mi_File_Merge
			// 
			this.mi_File_Merge.Index = 2;
			this.mi_File_Merge.Shortcut = System.Windows.Forms.Shortcut.CtrlShiftM;
			this.mi_File_Merge.Text = "&Merge...";
			this.mi_File_Merge.Click += new System.EventHandler(this.mi_File_Merge_Click);
			this.mi_File_Merge.Select += new System.EventHandler(this.mi_File_Merge_Select);
			// 
			// mi_File_Close
			// 
			this.mi_File_Close.Index = 3;
			this.mi_File_Close.Shortcut = System.Windows.Forms.Shortcut.CtrlW;
			this.mi_File_Close.Text = "&Close";
			this.mi_File_Close.Click += new System.EventHandler(this.mi_File_Close_Click);
			this.mi_File_Close.Select += new System.EventHandler(this.mi_File_Close_Select);
			// 
			// menuItem10
			// 
			this.menuItem10.Index = 4;
			this.menuItem10.Text = "-";
			// 
			// mi_File_Save
			// 
			this.mi_File_Save.Index = 5;
			this.mi_File_Save.Shortcut = System.Windows.Forms.Shortcut.CtrlS;
			this.mi_File_Save.Text = "&Save";
			this.mi_File_Save.Click += new System.EventHandler(this.mi_File_Save_Click);
			this.mi_File_Save.Select += new System.EventHandler(this.mi_File_Save_Select);
			// 
			// mi_File_SaveAs
			// 
			this.mi_File_SaveAs.Index = 6;
			this.mi_File_SaveAs.Shortcut = System.Windows.Forms.Shortcut.CtrlA;
			this.mi_File_SaveAs.Text = "Save &as...";
			this.mi_File_SaveAs.Click += new System.EventHandler(this.mi_File_SaveAs_Click);
			this.mi_File_SaveAs.Select += new System.EventHandler(this.mi_File_SaveAs_Select);
			// 
			// miMRUSeparator
			// 
			this.miMRUSeparator.Index = 7;
			this.miMRUSeparator.Text = "-";
			// 
			// mi_File_Exit
			// 
			this.mi_File_Exit.Index = 8;
			this.mi_File_Exit.Text = "E&xit";
			this.mi_File_Exit.Click += new System.EventHandler(this.mi_File_Exit_Click);
			this.mi_File_Exit.Select += new System.EventHandler(this.mi_File_Exit_Select);
			// 
			// mi_Edit
			// 
			this.mi_Edit.Index = 1;
			this.mi_Edit.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.mi_Edit_Undo,
																					this.mi_Edit_Find,
																					this.mi_Edit_FindAgain,
																					this.mi_Edit_GoTo,
																					this.menuItem3,
																					this.mi_Edit_Options,
																					this.menuItem2,
																					this.mi_Edit_Next,
																					this.mi_Edit_Previous});
			this.mi_Edit.Text = "&Edit";
			this.mi_Edit.Popup += new System.EventHandler(this.mi_Edit_Popup);
			// 
			// mi_Edit_Undo
			// 
			this.mi_Edit_Undo.Index = 0;
			this.mi_Edit_Undo.Shortcut = System.Windows.Forms.Shortcut.CtrlZ;
			this.mi_Edit_Undo.Text = "&Undo";
			this.mi_Edit_Undo.Click += new System.EventHandler(this.mi_Edit_Undo_Click);
			this.mi_Edit_Undo.Select += new System.EventHandler(this.mi_Edit_Undo_Select);
			// 
			// mi_Edit_Find
			// 
			this.mi_Edit_Find.Index = 1;
			this.mi_Edit_Find.Shortcut = System.Windows.Forms.Shortcut.CtrlF;
			this.mi_Edit_Find.Text = "&Find...";
			this.mi_Edit_Find.Click += new System.EventHandler(this.mi_Edit_Find_Click);
			// 
			// mi_Edit_FindAgain
			// 
			this.mi_Edit_FindAgain.Index = 2;
			this.mi_Edit_FindAgain.Shortcut = System.Windows.Forms.Shortcut.F3;
			this.mi_Edit_FindAgain.Text = "Find &next";
			this.mi_Edit_FindAgain.Click += new System.EventHandler(this.mi_Edit_FindAgain_Click);
			// 
			// mi_Edit_GoTo
			// 
			this.mi_Edit_GoTo.Index = 3;
			this.mi_Edit_GoTo.Shortcut = System.Windows.Forms.Shortcut.CtrlG;
			this.mi_Edit_GoTo.Text = "&Go to line...";
			this.mi_Edit_GoTo.Click += new System.EventHandler(this.mi_Edit_GoTo_Click);
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 4;
			this.menuItem3.Text = "-";
			// 
			// mi_Edit_Options
			// 
			this.mi_Edit_Options.Index = 5;
			this.mi_Edit_Options.Text = "&Options...";
			this.mi_Edit_Options.Click += new System.EventHandler(this.mi_Edit_Options_Click);
			this.mi_Edit_Options.Select += new System.EventHandler(this.mi_Edit_Options_Select);
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 6;
			this.menuItem2.Text = "-";
			// 
			// mi_Edit_Next
			// 
			this.mi_Edit_Next.Index = 7;
			this.mi_Edit_Next.Shortcut = System.Windows.Forms.Shortcut.CtrlN;
			this.mi_Edit_Next.Text = "Move &Next";
			this.mi_Edit_Next.Click += new System.EventHandler(this.mi_Edit_Next_Click);
			// 
			// mi_Edit_Previous
			// 
			this.mi_Edit_Previous.Index = 8;
			this.mi_Edit_Previous.Shortcut = System.Windows.Forms.Shortcut.CtrlP;
			this.mi_Edit_Previous.Text = "Move &Previous";
			this.mi_Edit_Previous.Click += new System.EventHandler(this.mi_Edit_Previous_Click);
			// 
			// mi_Action
			// 
			this.mi_Action.Index = 2;
			this.mi_Action.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.mi_Action_Renumber,
																					  this.mi_Action_Collapse,
																					  this.mi_Action_RemoveShort,
																					  this.mi_Action_RemoveIntra,
																					  this.menuItem1,
																					  this.mi_Action_SubDown,
																					  this.mi_Action_SubUp,
																					  this.menuItem4,
																					  this.mi_Action_ProcessJobs,
																					  this.mi_Action_ProcessDefault});
			this.mi_Action.Text = "&Action";
			this.mi_Action.Popup += new System.EventHandler(this.mi_Action_Popup);
			// 
			// mi_Action_Renumber
			// 
			this.mi_Action_Renumber.Index = 0;
			this.mi_Action_Renumber.Shortcut = System.Windows.Forms.Shortcut.CtrlR;
			this.mi_Action_Renumber.Text = "&Renumber";
			this.mi_Action_Renumber.Click += new System.EventHandler(this.mi_Action_Renumber_Click);
			this.mi_Action_Renumber.Select += new System.EventHandler(this.mi_Action_Renumber_Select);
			// 
			// mi_Action_Collapse
			// 
			this.mi_Action_Collapse.Index = 1;
			this.mi_Action_Collapse.Text = "&Collapse sequential duplicates";
			this.mi_Action_Collapse.Click += new System.EventHandler(this.mi_Action_Collapse_Click);
			// 
			// mi_Action_RemoveShort
			// 
			this.mi_Action_RemoveShort.Index = 2;
			this.mi_Action_RemoveShort.Text = "R&emove short duration items...";
			this.mi_Action_RemoveShort.Click += new System.EventHandler(this.mi_Action_RemoveShort_Click);
			// 
			// mi_Action_RemoveIntra
			// 
			this.mi_Action_RemoveIntra.Index = 3;
			this.mi_Action_RemoveIntra.Text = "Re&move intra-subtitle duplicate lines";
			this.mi_Action_RemoveIntra.Click += new System.EventHandler(this.mi_Action_RemoveIntra_Click);
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 4;
			this.menuItem1.Text = "-";
			// 
			// mi_Action_SubDown
			// 
			this.mi_Action_SubDown.Index = 5;
			this.mi_Action_SubDown.Shortcut = System.Windows.Forms.Shortcut.CtrlShiftD;
			this.mi_Action_SubDown.Text = "Move subtitles down one index";
			this.mi_Action_SubDown.Click += new System.EventHandler(this.mi_Action_SubDown_Click);
			// 
			// mi_Action_SubUp
			// 
			this.mi_Action_SubUp.Index = 6;
			this.mi_Action_SubUp.Shortcut = System.Windows.Forms.Shortcut.CtrlShiftU;
			this.mi_Action_SubUp.Text = "Move subtitles up one index";
			this.mi_Action_SubUp.Click += new System.EventHandler(this.mi_Action_SubUp_Click);
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 7;
			this.menuItem4.Text = "-";
			// 
			// mi_Action_ProcessJobs
			// 
			this.mi_Action_ProcessJobs.Index = 8;
			this.mi_Action_ProcessJobs.Text = "&Process .jobs file...";
			this.mi_Action_ProcessJobs.Click += new System.EventHandler(this.mi_Action_ProcessJobs_Click);
			this.mi_Action_ProcessJobs.Select += new System.EventHandler(this.mi_Action_ProcessJobs_Select);
			// 
			// mi_Action_ProcessDefault
			// 
			this.mi_Action_ProcessDefault.Index = 9;
			this.mi_Action_ProcessDefault.Shortcut = System.Windows.Forms.Shortcut.CtrlShiftJ;
			this.mi_Action_ProcessDefault.Text = "Process &default .jobs file";
			this.mi_Action_ProcessDefault.Click += new System.EventHandler(this.mi_Action_ProcessDefault_Click);
			this.mi_Action_ProcessDefault.Select += new System.EventHandler(this.mi_Action_ProcessDefault_Select);
			// 
			// mi_Help
			// 
			this.mi_Help.Index = 3;
			this.mi_Help.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.mi_Help_About});
			this.mi_Help.Text = "&Help";
			this.mi_Help.Popup += new System.EventHandler(this.mi_Help_Popup);
			// 
			// mi_Help_About
			// 
			this.mi_Help_About.Index = 0;
			this.mi_Help_About.Text = "&About SubFutzer...";
			this.mi_Help_About.Click += new System.EventHandler(this.mi_Help_About_Click);
			this.mi_Help_About.Select += new System.EventHandler(this.mi_Help_About_Select);
			// 
			// saveFileDialog1
			// 
			this.saveFileDialog1.FileName = "doc1";
			// 
			// statusBar1
			// 
			this.statusBar1.Location = new System.Drawing.Point(0, 361);
			this.statusBar1.Name = "statusBar1";
			this.statusBar1.Size = new System.Drawing.Size(656, 24);
			this.statusBar1.TabIndex = 1;
			this.statusBar1.Text = "Ready.";
			// 
			// splitter1
			// 
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.splitter1.Location = new System.Drawing.Point(0, 358);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(656, 3);
			this.splitter1.TabIndex = 2;
			this.splitter1.TabStop = false;
			this.splitter1.Visible = false;
			// 
			// panelControls
			// 
			this.panelControls.Controls.Add(this.cbWhichItems);
			this.panelControls.Controls.Add(this.label5);
			this.panelControls.Controls.Add(this.groupBox1);
			this.panelControls.Controls.Add(this.checkLockTimes);
			this.panelControls.Controls.Add(this.btnUpdate);
			this.panelControls.Controls.Add(this.tbSubtitle);
			this.panelControls.Controls.Add(this.label3);
			this.panelControls.Controls.Add(this.ttbStart);
			this.panelControls.Controls.Add(this.label1);
			this.panelControls.Controls.Add(this.ttbStop);
			this.panelControls.Controls.Add(this.label2);
			this.panelControls.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.panelControls.Location = new System.Drawing.Point(0, 214);
			this.panelControls.Name = "panelControls";
			this.panelControls.Size = new System.Drawing.Size(656, 144);
			this.panelControls.TabIndex = 0;
			// 
			// cbWhichItems
			// 
			this.cbWhichItems.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.helpProvider1.SetHelpString(this.cbWhichItems, "This selection determines the scope of the offset, line length, and merge command" +
				"s below it.");
			this.cbWhichItems.Items.AddRange(new object[] {
															  "All items",
															  "Selected items only"});
			this.cbWhichItems.Location = new System.Drawing.Point(184, 8);
			this.cbWhichItems.Name = "cbWhichItems";
			this.helpProvider1.SetShowHelp(this.cbWhichItems, true);
			this.cbWhichItems.Size = new System.Drawing.Size(120, 21);
			this.cbWhichItems.TabIndex = 1;
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(8, 12);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(184, 23);
			this.label5.TabIndex = 0;
			this.label5.Text = "The following commands will affect";
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.tbMaxLength);
			this.groupBox1.Controls.Add(this.label4);
			this.groupBox1.Controls.Add(this.btnSetMaxLength);
			this.groupBox1.Controls.Add(this.ttbOffset);
			this.groupBox1.Controls.Add(this.cbWhatAction);
			this.groupBox1.Controls.Add(this.checkNLBeforeBracket);
			this.groupBox1.Controls.Add(this.btnChange);
			this.groupBox1.Controls.Add(this.btnMergeAll);
			this.groupBox1.Location = new System.Drawing.Point(8, 32);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(304, 104);
			this.groupBox1.TabIndex = 2;
			this.groupBox1.TabStop = false;
			// 
			// tbMaxLength
			// 
			this.helpProvider1.SetHelpString(this.tbMaxLength, "The maximum number of characters a line can contain.");
			this.tbMaxLength.Location = new System.Drawing.Point(144, 48);
			this.tbMaxLength.Name = "tbMaxLength";
			this.helpProvider1.SetShowHelp(this.tbMaxLength, true);
			this.tbMaxLength.Size = new System.Drawing.Size(72, 20);
			this.tbMaxLength.TabIndex = 4;
			this.tbMaxLength.Text = "50";
			this.tbMaxLength.TextChanged += new System.EventHandler(this.tbMaxLength_TextChanged);
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(8, 51);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(144, 19);
			this.label4.TabIndex = 3;
			this.label4.Text = "Set maximum line length to ";
			// 
			// btnSetMaxLength
			// 
			this.helpProvider1.SetHelpString(this.btnSetMaxLength, "Breaks long (as defined by the length provided) at whitespace characters.");
			this.btnSetMaxLength.Location = new System.Drawing.Point(224, 48);
			this.btnSetMaxLength.Name = "btnSetMaxLength";
			this.helpProvider1.SetShowHelp(this.btnSetMaxLength, true);
			this.btnSetMaxLength.Size = new System.Drawing.Size(32, 23);
			this.btnSetMaxLength.TabIndex = 5;
			this.btnSetMaxLength.Text = "G&o";
			this.btnSetMaxLength.Click += new System.EventHandler(this.btnSetMaxLength_Click);
			// 
			// ttbOffset
			// 
			this.helpProvider1.SetHelpString(this.ttbOffset, "This is the offset (in H:M:S.ms format) used for the time offset functions.");
			this.ttbOffset.Location = new System.Drawing.Point(144, 16);
			this.ttbOffset.Name = "ttbOffset";
			this.helpProvider1.SetShowHelp(this.ttbOffset, true);
			this.ttbOffset.Size = new System.Drawing.Size(72, 24);
			this.ttbOffset.TabIndex = 1;
			// 
			// cbWhatAction
			// 
			this.cbWhatAction.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.helpProvider1.SetHelpString(this.cbWhatAction, @"This selection controls the method of time offsetting to use.  Select ""shift"" to move the subtitle times backwards or forwards by the specified amount.  ""Set first item"" sets the first subtitle to the specified value, offsetting the others to match it.  ""Expand last item"" sets the last item to the specified value, increasing or decreasing the times between it and the first subtitle (use this if the subtitles are aligned initially but slowly become misaligned through the video).");
			this.cbWhatAction.Items.AddRange(new object[] {
															  "Shift backwards by",
															  "Shift forwards by",
															  "Set first item to",
															  "Expand last item to",
															  "Expand by",
															  "Contract by"});
			this.cbWhatAction.Location = new System.Drawing.Point(8, 16);
			this.cbWhatAction.Name = "cbWhatAction";
			this.helpProvider1.SetShowHelp(this.cbWhatAction, true);
			this.cbWhatAction.Size = new System.Drawing.Size(128, 21);
			this.cbWhatAction.TabIndex = 0;
			// 
			// checkNLBeforeBracket
			// 
			this.checkNLBeforeBracket.Checked = true;
			this.checkNLBeforeBracket.CheckState = System.Windows.Forms.CheckState.Checked;
			this.helpProvider1.SetHelpString(this.checkNLBeforeBracket, "When checked during a line-merge operation, ignores line-breaks preceding the \"br" +
				"acket\" character.");
			this.checkNLBeforeBracket.Location = new System.Drawing.Point(104, 75);
			this.checkNLBeforeBracket.Name = "checkNLBeforeBracket";
			this.helpProvider1.SetShowHelp(this.checkNLBeforeBracket, true);
			this.checkNLBeforeBracket.Size = new System.Drawing.Size(192, 24);
			this.checkNLBeforeBracket.TabIndex = 7;
			this.checkNLBeforeBracket.Text = "Keep (add) newlines before a \"[\"";
			// 
			// btnChange
			// 
			this.helpProvider1.SetHelpString(this.btnChange, "Executes the time offset specified to the left.");
			this.btnChange.Location = new System.Drawing.Point(224, 16);
			this.btnChange.Name = "btnChange";
			this.helpProvider1.SetShowHelp(this.btnChange, true);
			this.btnChange.Size = new System.Drawing.Size(32, 24);
			this.btnChange.TabIndex = 2;
			this.btnChange.Text = "&Go";
			this.btnChange.Click += new System.EventHandler(this.btnChange_Click);
			// 
			// btnMergeAll
			// 
			this.helpProvider1.SetHelpString(this.btnMergeAll, "Removes all line breaks from the subtitles.");
			this.btnMergeAll.Location = new System.Drawing.Point(8, 75);
			this.btnMergeAll.Name = "btnMergeAll";
			this.helpProvider1.SetShowHelp(this.btnMergeAll, true);
			this.btnMergeAll.Size = new System.Drawing.Size(88, 23);
			this.btnMergeAll.TabIndex = 6;
			this.btnMergeAll.Text = "&Merge all lines";
			this.btnMergeAll.Click += new System.EventHandler(this.btnMergeAll_Click);
			// 
			// checkLockTimes
			// 
			this.helpProvider1.SetHelpString(this.checkLockTimes, "Locks the stop time to the start time.");
			this.checkLockTimes.Location = new System.Drawing.Point(368, 120);
			this.checkLockTimes.Name = "checkLockTimes";
			this.helpProvider1.SetShowHelp(this.checkLockTimes, true);
			this.checkLockTimes.Size = new System.Drawing.Size(272, 16);
			this.checkLockTimes.TabIndex = 10;
			this.checkLockTimes.Text = "C&hange stop time if start time is changed.";
			this.checkLockTimes.CheckedChanged += new System.EventHandler(this.checkLockTimes_CheckedChanged);
			// 
			// btnUpdate
			// 
			this.helpProvider1.SetHelpString(this.btnUpdate, "Updates the currently selected subtitle in the list view with the given text and " +
				"start/stop times.");
			this.btnUpdate.Location = new System.Drawing.Point(568, 96);
			this.btnUpdate.Name = "btnUpdate";
			this.helpProvider1.SetShowHelp(this.btnUpdate, true);
			this.btnUpdate.TabIndex = 9;
			this.btnUpdate.Text = "&Update";
			this.btnUpdate.Click += new System.EventHandler(this.btnUpdate_Click);
			// 
			// tbSubtitle
			// 
			this.helpProvider1.SetHelpString(this.tbSubtitle, "The text of the currently selected subtitle can be directly edited here (finalize" +
				" changes with the \"Update\" button).");
			this.tbSubtitle.Location = new System.Drawing.Point(368, 8);
			this.tbSubtitle.Multiline = true;
			this.tbSubtitle.Name = "tbSubtitle";
			this.tbSubtitle.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.helpProvider1.SetShowHelp(this.tbSubtitle, true);
			this.tbSubtitle.Size = new System.Drawing.Size(280, 80);
			this.tbSubtitle.TabIndex = 4;
			this.tbSubtitle.Text = "";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(328, 11);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(32, 16);
			this.label3.TabIndex = 3;
			this.label3.Text = "&Text:";
			// 
			// ttbStart
			// 
			this.helpProvider1.SetHelpString(this.ttbStart, "The start-time of the currently selected subtitle can be directly edited here (fi" +
				"nalize changes with the \"Update\" button).");
			this.ttbStart.Location = new System.Drawing.Point(368, 96);
			this.ttbStart.Name = "ttbStart";
			this.helpProvider1.SetShowHelp(this.ttbStart, true);
			this.ttbStart.Size = new System.Drawing.Size(72, 24);
			this.ttbStart.TabIndex = 6;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(328, 96);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(32, 16);
			this.label1.TabIndex = 5;
			this.label1.Text = "&Start:";
			// 
			// ttbStop
			// 
			this.helpProvider1.SetHelpString(this.ttbStop, "The stop-time of the currently selected subtitle can be directly edited here (fin" +
				"alize changes with the \"Update\" button).");
			this.ttbStop.Location = new System.Drawing.Point(488, 96);
			this.ttbStop.Name = "ttbStop";
			this.helpProvider1.SetShowHelp(this.ttbStop, true);
			this.ttbStop.Size = new System.Drawing.Size(72, 24);
			this.ttbStop.TabIndex = 8;
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(448, 96);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(32, 16);
			this.label2.TabIndex = 7;
			this.label2.Text = "Sto&p:";
			// 
			// splitter2
			// 
			this.splitter2.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.splitter2.Location = new System.Drawing.Point(0, 211);
			this.splitter2.Name = "splitter2";
			this.splitter2.Size = new System.Drawing.Size(656, 3);
			this.splitter2.TabIndex = 6;
			this.splitter2.TabStop = false;
			this.splitter2.Visible = false;
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.lvSubtitles);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(656, 211);
			this.panel1.TabIndex = 7;
			// 
			// SubFutzerForm
			// 
			this.AllowDrop = true;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(656, 385);
			this.Controls.Add(this.panel1);
			this.Controls.Add(this.splitter2);
			this.Controls.Add(this.panelControls);
			this.Controls.Add(this.splitter1);
			this.Controls.Add(this.statusBar1);
			this.HelpButton = true;
			this.Menu = this.mainMenu1;
			this.Name = "SubFutzerForm";
			this.Text = "SubFutzer [version]";
			this.KeyDown += new System.Windows.Forms.KeyEventHandler(this.SubFutzerForm_KeyDown);
			this.Resize += new System.EventHandler(this.SubFutzerForm_Resize);
			this.Closing += new System.ComponentModel.CancelEventHandler(this.SubFutzerForm_Closing);
			this.Load += new System.EventHandler(this.SubFutzerForm_Load);
			this.DragDrop += new System.Windows.Forms.DragEventHandler(this.SubFutzerForm_DragDrop);
			this.DragEnter += new System.Windows.Forms.DragEventHandler(this.SubFutzerForm_DragEnter);
			this.panelControls.ResumeLayout(false);
			this.groupBox1.ResumeLayout(false);
			this.panel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new SubFutzerForm());
		}

        private bool CanClearCurrentFile()
        {
            if ((lvSubtitles.Items.Count > 0) && (m_bDirty))
            {
                if (MessageBox.Show(this, "This will clear all of the current subtitles.  Continue?", "Clear all subtitles?", MessageBoxButtons.YesNo) != DialogResult.Yes)
                    return false;
            }
            return true;
        }
            
        public void ClearCurrentFile()
        {
            lvSubtitles.Items.Clear();
            m_bDirty = false;
            SetFileName("");
        }

        private void mi_File_Open_Click(object sender, System.EventArgs e)
        {
            if (!CanClearCurrentFile())
                return;

            openFileDialog1.DefaultExt = "srt";
            openFileDialog1.Multiselect = false;
            openFileDialog1.Title = "Select subtitle file to open";
            openFileDialog1.Filter = "SubRip files (*.srt)|*.srt|All files (*.*)|*.*";
            if (openFileDialog1.ShowDialog(this) == DialogResult.OK)
            {
                SaveUndoData();
                ClearCurrentFile();
                ReadSubtitleFile(openFileDialog1.FileName);
            }
        }

        private int GetNextNumber(string sNumbers, ref int iIndex)
        {
            int iStart = iIndex;

            while (true)
            {
                iIndex++;
                if (iIndex >= sNumbers.Length)
                    break;
                if (!Char.IsDigit(sNumbers,iIndex))
                    break;
            }

            return SafeConvertInt32(sNumbers.Substring(iStart, iIndex - iStart));
        }

        private Subtitle ReadSubtitle(StreamReader reader)
        {
            Subtitle sub = new Subtitle();
            string sLine = "";
            bool bContinue = true;

            // Read the index number
            while (bContinue)
            {
                sLine = reader.ReadLine();
                if (reader.Peek() == -1)
                    return sub;
                if (sLine.Length < 1)
                    continue;
                if (Char.IsDigit(sLine, 0))
                    break;
            }

            sub.Index = SafeConvertInt32(sLine, 10);

            // Read the start/stop times
            sLine = "";
            while (bContinue)
            {
                sLine = reader.ReadLine();
                if (reader.Peek() == -1)
                    return sub;
                if (sLine.Length < 1)
                    continue;
                if (Char.IsDigit(sLine, 0))
                    break;
            }

            int[] iNumbers = new int[8] {0,0,0,0,0,0,0,0};
            int iIndex = 0;

            for (int i = 0; i < 8; i++)
            {
                iNumbers[i] = GetNextNumber(sLine, ref iIndex);
				if (i == 7)
					break;
                while (bContinue)
                {
                    iIndex++;
                    if (iIndex >= sLine.Length)
                        break;
                    if (Char.IsDigit(sLine, iIndex))
                        break;
                }
                if (iIndex >= sLine.Length)
                    break;
            }

            sub.StartTime = new DateTime(1, 1, 1, iNumbers[0], iNumbers[1], iNumbers[2], iNumbers[3]);
            sub.StopTime = new DateTime(1, 1, 1, iNumbers[4], iNumbers[5], iNumbers[6], iNumbers[7]);

			// Read any variables that are listed after the subtitle times
			int iVarStart = -1;
			int iVarEnd = -1;
			int iValueStart = -1;
			int iValueEnd = -1;
			string sVariable = "";
			string sValue = "";
			while (iIndex <= sLine.Length)
			{
				if ((iIndex < sLine.Length) && (!Char.IsWhiteSpace(sLine, iIndex)))
				{
					if (sLine[iIndex] == ':')
					{
						iVarEnd = iIndex;
						iValueStart = iIndex+1;
					}
					else if (iVarStart < 0)
						iVarStart = iIndex;
					else if (iValueStart < 0)
						iVarEnd = iIndex;
					else
						iValueEnd = iIndex;
				}
				else
				{
					// Whitespace terminates any active variable
					iValueEnd = iIndex;
					if ((iValueStart >= 0) && (iVarStart >= 0))
					{
						sVariable = sLine.Substring(iVarStart, iVarEnd - iVarStart);
						sValue = sLine.Substring(iValueStart, iValueEnd - iValueStart);
						
						// Check for variables we understand
						if (string.Compare(sVariable, "X1", true) == 0)
							sub.rcBound.X = SafeConvertInt32(sValue);
						else if (string.Compare(sVariable, "X2", true) == 0)
							sub.rcBound.Width = SafeConvertInt32(sValue) - sub.rcBound.X;
						else if (string.Compare(sVariable, "Y1", true) == 0)
							sub.rcBound.Y = SafeConvertInt32(sValue);
						else if (string.Compare(sVariable, "Y2", true) == 0)
							sub.rcBound.Height = SafeConvertInt32(sValue) - sub.rcBound.Y;
					}
					iVarStart = -1;
					iVarEnd = -1;
					iValueStart = -1;
					iValueEnd = -1;
					sVariable = "";
					sValue = "";
				}
				iIndex++;
			}

            // Read the subtitles
            sub.Text = "";
            do
            {
                if (reader.Peek() == -1)
                    break;

                sLine = reader.ReadLine();
                if ((sub.Text.Length > 0) && (sLine != ""))
                    sub.Text += "\r\n";

                sub.Text += sLine;
                sub.Valid = true;
            } while (sLine != "");
            
            return sub;
        }

        private int InsertSubtitleIntoList(Subtitle sub)
        {
            ListViewItem lvItem = new ListViewItem();
            UpdateLVItem(lvItem, sub);
            return lvSubtitles.Items.Add(lvItem).Index;
        }

        private void UpdateLVItem(ListViewItem lvItem, Subtitle sub)
        {
            lvItem.Tag = sub;
            lvItem.SubItems.Clear();
            lvItem.Text = sub.Index.ToString();
            lvItem.SubItems.Add(sub.StartTime.ToString("HH:mm:ss.fff"));
            lvItem.SubItems.Add(sub.StopTime.ToString("HH:mm:ss.fff"));
            lvItem.SubItems.Add((sub.StopTime - sub.StartTime).TotalMilliseconds.ToString());
            lvItem.SubItems.Add(sub.Text);
        }

        private void UpdateLVItem(ListViewItem lvItem)
        {
            UpdateLVItem(lvItem, (Subtitle) lvItem.Tag);
        }

        private void UpdateProgress(long iCurrent, long iMaximum)
        {
            statusBar1.Text = "Processing: " + (iCurrent * 100 / (double) iMaximum).ToString("0.0") + "%";
        }

        public void ReadSubtitleFile(string sFileName)
        {
            SetReadyStatus();
            bool bSequence = true;
            int iFirstMisaligned = -1;
            int iMisalignedCorrected = -1;
            lvSubtitles.SuspendLayout();
            StreamReader reader = new StreamReader(sFileName, Encoding.Default);
            Subtitle sub;
            int iPrevIndex = 0;

            while (reader.Peek() != -1)
            {
                sub = ReadSubtitle(reader);
                if (sub.Valid)
                    InsertSubtitleIntoList(sub);
                if (sub.Index != iPrevIndex + 1)
                {
                    bSequence = false;
                    if (iFirstMisaligned == -1)
                    {
                        iFirstMisaligned = sub.Index;
                        iMisalignedCorrected = iPrevIndex + 1;
                    }
                }
                UpdateProgress(reader.BaseStream.Position, reader.BaseStream.Length);
                iPrevIndex++;
            }
            reader.Close();
            foreach(ColumnHeader ch in lvSubtitles.Columns)
            {
                ch.Width = -2;
            }

            lvSubtitles.ResumeLayout();
            m_bDirty = false;
            SetFileName(sFileName);
            AddFileToMRU(sFileName);
            if (bSequence)
                SetReadyStatus();
            else
                statusBar1.Text = "Warning: Indices non-consecutive (" + iFirstMisaligned.ToString() + " should be " + iMisalignedCorrected.ToString() + ").  Use the Action->Renumber command to resequence.";
        }

        public void SetReadyStatus()
        {
            statusBar1.Text = "Ready.";
        }

        private void SubFutzerForm_DragDrop(object sender, System.Windows.Forms.DragEventArgs e)
        {
            GenericDragDrop(sender, e);
        }

        private void GenericDragDrop(object sender, System.Windows.Forms.DragEventArgs e)
        {
            string[] saFiles = (string[]) e.Data.GetData(DataFormats.FileDrop);
            if (saFiles.Length > 0)
            {
                if (File.Exists(saFiles[0]))
                {
                    if (CanClearCurrentFile())
                    {
                        SaveUndoData();
                        ClearCurrentFile();
                        ReadSubtitleFile(saFiles[0]);
                    }
                }
            }
        }

        private void lvSubtitles_DragDrop(object sender, System.Windows.Forms.DragEventArgs e)
        {
            GenericDragDrop(sender, e);
        }

        private void SubFutzerForm_DragEnter(object sender, System.Windows.Forms.DragEventArgs e)
        {
            Generic_DragEnter(sender, e);
        }

        private void Generic_DragEnter(object sender, System.Windows.Forms.DragEventArgs e)
        {
            if(e.Data.GetDataPresent(DataFormats.FileDrop))
                e.Effect = DragDropEffects.Copy;
        }

        private void lvSubtitles_DragEnter(object sender, System.Windows.Forms.DragEventArgs e)
        {
            Generic_DragEnter(sender, e);
        }

        private void mi_File_Close_Click(object sender, System.EventArgs e)
        {
            if (CanClearCurrentFile())
                ClearCurrentFile();
        }

        private void mi_File_New_Click(object sender, System.EventArgs e)
        {
            if (CanClearCurrentFile())
            {
                SaveUndoData();
                ClearCurrentFile();
            }
        }

        private void SaveFileAs()
        {
            saveFileDialog1.DefaultExt = "srt";
            saveFileDialog1.Title = "Save the current subtitle file as";
            saveFileDialog1.Filter = "SubRip files (*.srt)|*.srt|All files (*.*)|*.*";
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                SaveFile(saveFileDialog1.FileName);
            }
        }

        private void WriteSubtitle(StreamWriter writer, ListViewItem lvItem)
        {
            WriteSubtitle(writer, (Subtitle) lvItem.Tag);
        }

        private void WriteSubtitle(StreamWriter writer, Subtitle sub)
        {
            writer.WriteLine(sub.Index);
			string sExtended = "";
			if (!sub.rcBound.IsEmpty)
			{
				sExtended = string.Format("  X1:{0:000} X2:{1:000} Y1:{2:000} Y2:{3:000}",
					sub.rcBound.Left,
					sub.rcBound.Right,
					sub.rcBound.Top,
					sub.rcBound.Bottom);
			}
            writer.WriteLine("{0:00}:{1:00}:{2:00},{3:000} --> {4:00}:{5:00}:{6:00},{7:000}{8}",
                sub.StartTime.Hour,
                sub.StartTime.Minute,
                sub.StartTime.Second,
                sub.StartTime.Millisecond,
                sub.StopTime.Hour,
                sub.StopTime.Minute,
                sub.StopTime.Second,
                sub.StopTime.Millisecond,
				sExtended);

            writer.WriteLine(sub.Text + "\r\n");
        }

        public void SaveFile()
        {
            int iIndex = 0;
            try
            {
                StreamWriter writer = new StreamWriter(m_sFileName, false, Encoding.Default);
                while (iIndex < lvSubtitles.Items.Count)
                {
                    UpdateProgress(iIndex, lvSubtitles.Items.Count);
                    WriteSubtitle(writer, lvSubtitles.Items[iIndex]);
                    iIndex++;
                }
                writer.Close();
                m_bDirty = false;
            }
            catch(Exception e)
            {
                MessageBox.Show(this, "Could not write to file \"" + m_sFileName + "\" (Error: " + e.Message + ")");
            }
            SetReadyStatus();
        }

        public void SaveFile(string sFileName)
        {
            SetFileName(sFileName);

            SaveFile();
        }

        private void SetFileName(string sFileName)
        {
            m_sFileName = sFileName;
            if (sFileName != "")
                this.Text = "SubFutzer - " + sFileName;
            else
                this.Text = "SubFutzer";
        }

        private void mi_File_Save_Click(object sender, System.EventArgs e)
        {
            if (m_sFileName == "")
                SaveFileAs();
            else
                SaveFile(m_sFileName);
        }

        private void mi_File_SaveAs_Click(object sender, System.EventArgs e)
        {
            SaveFileAs();
        }

        private void mi_Edit_Offset_Click(object sender, System.EventArgs e)
        {
        
        }

        private void lvSubtitles_SelectedIndexChanged(object sender, System.EventArgs e)
        {
            if (lvSubtitles.SelectedItems.Count < 1)
                return;

			if (lvSubtitles.SelectedItems.Count > 1)
				return;

			Subtitle sub = (Subtitle) lvSubtitles.SelectedItems[0].Tag;
            tbSubtitle.Text = sub.Text;
            ttbStart.SetTime(sub.StartTime);
            ttbStop.SetTime(sub.StopTime);
            LockTimes();
        }

        private void SubFutzerForm_Resize(object sender, System.EventArgs e)
        {
            if (!m_bInitialized)
                return;

            int iWidth = panelControls.Width - tbSubtitle.Left;
            if (iWidth > 30)
                tbSubtitle.Width = iWidth;
        }

        private void OffsetSubtitle(ListViewItem lvItem, TimeSpan tsFirst, double fRatio)
        {
            Subtitle sub = (Subtitle) lvItem.Tag;
            TimeSpan tsDuration = sub.StopTime - sub.StartTime;
            TimeSpan tsStart = TimeToolbox.DateTimeToTimeSpan(sub.StartTime);
            TimeSpan tsOffset = tsStart - tsFirst;
            sub.StartTime = TimeToolbox.TimeSpanToDateTime(new TimeSpan(0,0,0,0, (int) ((tsOffset.TotalMilliseconds * fRatio) + tsFirst.TotalMilliseconds)));
            sub.StopTime = sub.StartTime.Add(tsDuration);
            UpdateLVItem(lvItem);
        }

        private void OffsetSubtitle(ListViewItem lvItem, TimeSpan ts)
        {
            Subtitle sub = (Subtitle) lvItem.Tag;
            try
            {
                sub.StartTime += ts;
            }
            catch
            {
                sub.StartTime = new DateTime(1, 1, 1, 0, 0, 0, 0);
            }
            try
            {
                sub.StopTime += ts;
            }
            catch
            {
                sub.StopTime = new DateTime(1, 1, 1, 0, 0, 0, 0);
            }
            UpdateLVItem(lvItem);
        }

        private bool ProcessAllItems()
        {
            if (cbWhichItems.SelectedIndex == 0)
                return true;
            return false;
        }

        public void OffsetSubtitles(TimeSpan ts)
        {
            if (ProcessAllItems())
            {
                foreach(ListViewItem lvItem in lvSubtitles.Items)
                {
                    OffsetSubtitle(lvItem, ts);
                }
            } 
            else
            {
                foreach(ListViewItem lvItem in lvSubtitles.SelectedItems)
                {
                    OffsetSubtitle(lvItem, ts);
                }
            }
        }

        public void SetFirstItem(TimeSpan ts)
        {
            Subtitle sub;
            if (ProcessAllItems())
            {
                if (lvSubtitles.Items.Count < 1)
                    return;
                sub = (Subtitle) lvSubtitles.Items[0].Tag;
            } 
            else
            {
                if (lvSubtitles.SelectedItems.Count < 1)
                    return;
                sub = (Subtitle) lvSubtitles.SelectedItems[0].Tag;
            }
            TimeSpan tsSet = ts - TimeToolbox.DateTimeToTimeSpan(sub.StartTime);
            OffsetSubtitles(tsSet);
        }

        private bool VerifyDuration(ListViewItem lviFirst, ListViewItem lviNext)
        {
            Subtitle subFirst = (Subtitle) lviFirst.Tag;
            Subtitle subNext = (Subtitle) lviNext.Tag;

            if (subFirst.StopTime <= subNext.StartTime)
                return true;

            subFirst.StopTime = subNext.StartTime;
            UpdateLVItem(lviFirst, subFirst);

            return false;
        }

        public void ExpandLastItem(TimeSpan ts)
        {
            ExpandLastItem(ts, false);
        }

        public void ExpandLastItem(TimeSpan ts, bool bRelative)
        {
            if (lvSubtitles.Items.Count < 2)
                return;

            int iIndexFirst, iIndexLast;
            if (ProcessAllItems() || (lvSubtitles.SelectedItems.Count < 1))
            {
                iIndexFirst = 0;
                iIndexLast = lvSubtitles.Items.Count - 1;
            } 
            else
            {
                if (lvSubtitles.SelectedItems.Count < 2)
                    return;
                iIndexFirst = lvSubtitles.SelectedIndices[0];
                iIndexLast = lvSubtitles.SelectedIndices[lvSubtitles.SelectedIndices.Count - 1];
            }
            Subtitle subFirst = (Subtitle) lvSubtitles.Items[iIndexFirst].Tag;
            Subtitle subLast = (Subtitle) lvSubtitles.Items[iIndexLast].Tag;
            TimeSpan tsOld = subLast.StartTime - subFirst.StartTime;
            TimeSpan tsNew;

            if (bRelative)
            {
                tsNew = (TimeToolbox.DateTimeToTimeSpan(subLast.StartTime) + ts) - TimeToolbox.DateTimeToTimeSpan(subFirst.StartTime);
            }
            else
            {
                tsNew = ts - TimeToolbox.DateTimeToTimeSpan(subFirst.StartTime);
            }

            double fRatio = tsNew.TotalMilliseconds / tsOld.TotalMilliseconds;

            int iCurrent = iIndexFirst;
            while (iCurrent <= iIndexLast)
            {
                OffsetSubtitle(lvSubtitles.Items[iCurrent], TimeToolbox.DateTimeToTimeSpan(subFirst.StartTime), fRatio);
                if (iCurrent > iIndexFirst)
                    VerifyDuration(lvSubtitles.Items[iCurrent - 1], lvSubtitles.Items[iCurrent]);
                iCurrent++;
            }
        }

        public void ExpandSubtitles(TimeSpan tsExpand)
        {
            ExpandLastItem(tsExpand, true);
        }

        private void btnChange_Click(object sender, System.EventArgs e)
        {
            SaveUndoData();
            switch(cbWhatAction.SelectedIndex)
            {
                case 0: // Backwards
                    OffsetSubtitles(-ttbOffset.GetTime());
                    m_bDirty = true;
                    break;
                case 1: // Forwards
                    OffsetSubtitles(ttbOffset.GetTime());
                    m_bDirty = true;
                    break;
                case 2: // Set first item
                    SetFirstItem(ttbOffset.GetTime());
                    m_bDirty = true;
                    break;
                case 3: // Expand last item
                    ExpandLastItem(ttbOffset.GetTime());
                    m_bDirty = true;
                    break;
                case 4: // Expand by
                    ExpandSubtitles(ttbOffset.GetTime());
                    m_bDirty = true;
                    break;
                case 5: // Contract by
                    ExpandSubtitles(-ttbOffset.GetTime());
                    m_bDirty = true;
                    break;
                default:
                    break;
            }
        }

        private void btnUpdate_Click(object sender, System.EventArgs e)
        {
            SaveUndoData();
            if (lvSubtitles.SelectedItems.Count < 1)
                return;

            ListViewItem lvItem = lvSubtitles.SelectedItems[0];
            Subtitle sub = (Subtitle) lvItem.Tag;
            sub.Text = tbSubtitle.Text;
            sub.StartTime = TimeToolbox.TimeSpanToDateTime(ttbStart.GetTime());
            sub.StopTime = TimeToolbox.TimeSpanToDateTime(ttbStop.GetTime());
            UpdateLVItem(lvItem);

            m_bDirty = true;
        }

        private void LockTimes()
        {
            if (checkLockTimes.Checked)
            {
                ttbStart.SetLock(ttbStop);
            } 
            else
            {
                ttbStart.SetLock(null);
            }
        }

        private void checkLockTimes_CheckedChanged(object sender, System.EventArgs e)
        {
            LockTimes();
        }

        private void mi_Edit_Options_Click(object sender, System.EventArgs e)
        {
            SFOptionsForm optionsForm = new SFOptionsForm();
            optionsForm.m_options = m_options;
            optionsForm.ShowDialog();
            m_options = optionsForm.m_options;
        }

        public void ProcessJobs()
        {
            openFileDialog2.DefaultExt = "jobs";
            openFileDialog2.Multiselect = false;
            openFileDialog2.Title = "Select VirtualDub-format job file for processing";
            openFileDialog2.Filter = "VirtualDub job files (*.jobs)|*.jobs|All files (*.*)|*.*";
            if (openFileDialog2.ShowDialog(this) == DialogResult.OK)
                ProcessJobs(openFileDialog2.FileName);
        }

        private string GetRegexMatch(string sRegex, string sSearch)
        {
            Regex regex = new Regex(sRegex);
            CaptureCollection cc;

            Match match = regex.Match(sSearch);
            if (match.Groups.Count > 0)
            {
                cc = match.Groups[0].Captures;
                if (cc.Count > 0)
                {
                    return match.Result("${1}");
                }
            }
            return "";
        }

        enum PJState
        {
            FindAVISource,
            FindRange,
            FindAVIDest,
            Finish
        }

        public void ProcessJobs(string sFileName)
        {
            StreamReader reader;
            string sLine;
            string sAVISource = "";
            string sRange = "";
            string sAVIDest = "";
            int iFind;
            long lStart = 0;
            long lEnd = 0;
            PJState state = PJState.FindAVISource;

            try
            {
                reader = new StreamReader(sFileName, Encoding.Default);
            }
            catch
            {
                MessageBox.Show(this, "Could not open file \"" + sFileName + "\" for reading.");
                return;
            }

            while (reader.Peek() != -1)
            {
                sLine = reader.ReadLine();

                switch(state)
                {
                    case PJState.FindAVISource:
                        sAVISource = GetRegexMatch("VirtualDub.Open\\(\"(?<1>.*)\"", sLine);
                        if (sAVISource != "")
                        {
                            state++;
                            sAVISource = sAVISource.Replace("\\\\", "\\");
                        }
                        break;
                    case PJState.FindRange:
                        sRange = GetRegexMatch("VirtualDub.video.SetRange\\((?<1>.*)\\)", sLine);
                        if (sRange != "")
                        {
                            state++;
                            iFind = sRange.IndexOf(',');
                            lStart = Convert.ToInt64(sRange.Substring(0, iFind));
                            lEnd = Convert.ToInt64(sRange.Substring(iFind+1));
                        }
                        break;
                    case PJState.FindAVIDest:
                        sAVIDest = GetRegexMatch("VirtualDub.SaveAVI\\(\"(?<1>.*)\"", sLine);
                        if (sAVIDest != "")
                        {
                            state++;
                            sAVIDest = sAVIDest.Replace("\\\\", "\\");
                            if (m_options.bStripLanguage)
                                sAVIDest = RemoveLanguageString(sAVIDest);
                        }
                        break;
                    case PJState.Finish:
                        FitSubtitlesToJob(sAVISource, lStart, lEnd, sAVIDest);
                        state = PJState.FindAVISource;
                        break;
                    default:
                        break;
                }

            }
            reader.Close();
        }

        private string RemoveLanguageString(string sAVI)
        {
            string sTemp = sAVI.ToLower();
            int iIndex = -1;

            string[] saLanguages = { "english", "japanese", "chinese", "spanish", "french" };

            // Assume there is at most only a single language string
            foreach(string sLanguage in saLanguages)
            {
                iIndex = sTemp.IndexOf("-" + sLanguage + ".avi");
                if (iIndex > -1)
                    return sAVI.Substring(0, iIndex) + ".avi";
            }

            return sAVI;
        }

        private void WriteSubtitleSection(long lStartMS, long lStopMS, string sFileName)
        {
            int iCurrent = 0;
            int iSubIndex = 1;
            Subtitle sub, newSub;
            long lSubMS;
            StreamWriter writer;

            try
            {
                writer = new StreamWriter(sFileName, false, Encoding.Default);
            }
            catch
            {
                MessageBox.Show(this, "Unable to open file \"" + sFileName +"\" for writing.");
                return;
            }

            while (iCurrent < lvSubtitles.Items.Count)
            {
                sub = (Subtitle) lvSubtitles.Items[iCurrent].Tag;
                lSubMS = TimeToolbox.DateTimeToMilliseconds(sub.StartTime);
                if ((lSubMS > lStartMS) && (lSubMS < lStopMS))
                {
                    newSub = sub.SubtractMS(lStartMS);
                    newSub.Index = iSubIndex;
                    WriteSubtitle(writer, newSub);
                    iSubIndex++;
                }

                iCurrent++;

                if (lSubMS > lStopMS)
                    break;  // No sense processing any further if we're past the end of the segment
            }

            writer.Close();
        }

        private long DWordAt(byte[] buffer, int iOffset)
        {
            return Convert.ToInt64(buffer[iOffset] | (buffer[iOffset+1] << 8) | (buffer[iOffset+2] << 16) | (buffer[iOffset+3] << 24));
        }

        private void FitSubtitlesToJob(string sAVISource, long lStartMS, long lEndMS, string sAVIDest)
        {
            SetReadyStatus();

            // VirtualDub gives us the ending in ms from the END of the file...
            FileStream fs;
            try
            {
                fs = File.OpenRead(sAVISource);

                BinaryReader reader = new BinaryReader(fs);
                byte[] buffer = new byte[512];
                reader.Read(buffer, 0, 512);
                double fSecPerFrame = DWordAt(buffer, 0x80) / (double) DWordAt(buffer, 0x84);
                long lTotalFrames = DWordAt(buffer, 0x8c);
                reader.Close();

                if (fSecPerFrame < 0.0001)
                {
                    // Invalid frame rate
                    lEndMS = 99999999;
                } 
                else
                {
                    lEndMS = (long) ((lTotalFrames * fSecPerFrame) * 1000) - lEndMS;
                }
            }
            catch (Exception e)
            {
                lEndMS = 99999999;
                SetStatus("Warning:  Could not determine length of file " + sAVISource + " [" + e.Message + "]");
            }

            string sFileName = Path.GetDirectoryName(sAVIDest)
                + "\\"
                + m_options.sSubOutFormat.Replace("%N",Path.GetFileNameWithoutExtension(sAVIDest));
            WriteSubtitleSection(lStartMS, lEndMS, sFileName);

/* useless
            FilgraphManager graphManager =
                new FilgraphManager();

            // QueryInterface for the IMediaControl interface:
            IMediaControl mc = 
                (IMediaControl)graphManager;

            IMediaSeeking ms =
                (IMediaSeeking)graphManager;

            // Call some methods on a COM interface.
            // Pass in file to RenderFile method on COM object.
            mc.RenderFile(sAVISource);
        
            long lDuration, lPosition;
            double dRate;
//            ms.IsUsingTimeFormat(TimeFormat.MediaTime);
            ms.GetDuration(out lDuration);
            ms.GetCurrentPosition(out lPosition);
            ms.GetRate(out dRate);
*/
        }

        private void WarnNoSubtitles()
        {
            MessageBox.Show(this, "There are no subtitles loaded.\n\nBefore processing a .jobs file, load in a set of subtitles with the File->Open command.", "Warning", MessageBoxButtons.OK, MessageBoxIcon.Stop); 
        }

        private void mi_Action_ProcessJobs_Click(object sender, System.EventArgs e)
        {
            if (lvSubtitles.Items.Count < 1)
            {
                WarnNoSubtitles();
                return;
            }

            ProcessJobs();
        }

        private void mi_Action_ProcessDefault_Click(object sender, System.EventArgs e)
        {
            if (lvSubtitles.Items.Count < 1)
            {
                WarnNoSubtitles();
                return;
            }

            if (File.Exists(m_options.sVDJobsFile))
                ProcessJobs(m_options.sVDJobsFile);
            else
                ProcessJobs();
        }

        private void MergeLines(ListViewItem lvItem)
        {
            Subtitle sub = (Subtitle) lvItem.Tag;
            int iLine = 0;
            int iFind;
            char[] caNewLine = new char[2] {'\r', '\n'};
            string sBefore, sAfter;
            while (iLine != -1)
            {
                iLine = sub.Text.IndexOfAny(caNewLine);
                if (iLine > 0)
                    sBefore = sub.Text.Substring(0, iLine);
                else
                    sBefore = "";

                sAfter = "";
                iFind = iLine+1;
                while (iFind < sub.Text.Length)
                {
                    if (Char.IsWhiteSpace(sub.Text[iFind]))
                    {
                        iFind++;
                    }
                    else
                    {
                        sAfter = sub.Text.Substring(iFind);
                        break;
                    }
                }
                
                if ((sBefore != "") && (sAfter != ""))
                {
                    switch(sub.Text[iLine-1])
                    {
                        case '!':
                        case '?':
                        case '.':
                            sub.Text = sBefore + "  " + sAfter;
                            break;
                        default:
                            sub.Text = sBefore + " " + sAfter;
                            break;
                    }
                } 
                else
                {
                    sub.Text = sBefore + sAfter;
                }

            }

            if (checkNLBeforeBracket.Checked)
            {
                sub.Text = sub.Text.Replace(" [", "[").Replace("[", "\r\n[");
            }

            UpdateLVItem(lvItem, sub);
        }

        private void btnMergeAll_Click(object sender, System.EventArgs e)
        {
            SaveUndoData();
            if (ProcessAllItems())
            {
                foreach(ListViewItem lvItem in lvSubtitles.Items)
                    MergeLines(lvItem);
            } 
            else
            {
                foreach(ListViewItem lvItem in lvSubtitles.SelectedItems)
                    MergeLines(lvItem);
            }
            m_bDirty = true;
        }

        private bool IsCRLF(char c)
        {
            if (c == '\r' || c == '\n')
                return true;
            return false;
        }

		private bool IsOneOf(char cTest, char[] arrayChars)
		{
			foreach(char c in arrayChars)
				if (cTest == c)
					return true;
			return false;
		}

        private void SetMaxLineLength(ListViewItem lvItem, int iMaxLen)
        {
            Subtitle sub = (Subtitle) lvItem.Tag;
            if (sub.Text.Length <= iMaxLen)
                return;

            int iFind = 0;
            int iCurLen = 0;
            int iSpace = 0;
            bool bCRBeforeBracket = false;
            if (checkNLBeforeBracket.Checked)
                bCRBeforeBracket = true;

            while (iFind < sub.Text.Length)
            {
                if (IsCRLF(sub.Text[iFind]))
                {
                    iCurLen = 0;
                    while ((iFind < sub.Text.Length) && (IsCRLF(sub.Text[iFind])))
                        iFind++;
                }

                if (iFind >= sub.Text.Length)
                    break;

                if (sub.Text[iFind] == ' ')
                    iSpace = iFind;

                if (bCRBeforeBracket)
                {
                    if (sub.Text[iFind] == '[')
                    {
                        if (iFind > 0)
                        {
                            if (!IsCRLF(sub.Text[iFind-1]))
                            {
                                sub.Text = sub.Text.Substring(0, iFind) + "\r\n" + sub.Text.Substring(iFind);
                                iFind += 2;
                            }
                        }
                    }
                }

                if (iCurLen > iMaxLen)
                {
                    if ((iSpace > 0) && (iSpace < sub.Text.Length - 1))
                    {
                        sub.Text = sub.Text.Substring(0, iSpace) + "\r\n" + sub.Text.Substring(iSpace+1);
                        iFind = iSpace + 2;
                        iCurLen = 0;
                        iSpace = 0;
                    }
                    // If there's no spaces, don't split anything.
                }
                iFind++;
                iCurLen++;
            }
            UpdateLVItem(lvItem, sub);
        }

        private void btnSetMaxLength_Click(object sender, System.EventArgs e)
        {
            SaveUndoData();
            int iLength = 60;

            try { iLength = SafeConvertInt32(tbMaxLength.Text); }
            catch { iLength = 60; }

            if (ProcessAllItems())
            {
                foreach(ListViewItem lvItem in lvSubtitles.Items)
                    SetMaxLineLength(lvItem, iLength);
            } 
            else
            {
                foreach(ListViewItem lvItem in lvSubtitles.SelectedItems)
                    SetMaxLineLength(lvItem, iLength);
            }
            m_bDirty = true;
        }

        private void RenumberAllSubtitles()
        {
            int iCurrent = 0;
            while (iCurrent < lvSubtitles.Items.Count)
            {
                ((Subtitle) lvSubtitles.Items[iCurrent].Tag).Index = iCurrent + 1;
                UpdateLVItem(lvSubtitles.Items[iCurrent]);
                iCurrent++;
            }
            SetReadyStatus();
            m_bDirty = true;
        }

        private void mi_Action_Renumber_Click(object sender, System.EventArgs e)
        {
            SaveUndoData();
            RenumberAllSubtitles();
        }

        private void SubFutzerForm_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            if (m_bDirty)
            {
                DialogResult result = MessageBox.Show(this, "Do you wish to save your changes?", "Unsaved Changes", MessageBoxButtons.YesNoCancel, MessageBoxIcon.Exclamation);
                if (result == DialogResult.Cancel)
                    e.Cancel = true;
                else if (result == DialogResult.Yes)
                    SaveFile(m_sFileName);
            } 

            m_options.WriteToRegistry();
        }

        private void DeleteSelectedItems()
        {
			lvSubtitles.SuspendLayout();
            foreach(ListViewItem lvItem in lvSubtitles.SelectedItems)
            {
                lvItem.Remove();
            }
            RenumberAllSubtitles();  // also sets m_bDirty
			lvSubtitles.ResumeLayout();
        }

        private void mi_Context_DeleteSelected_Click(object sender, System.EventArgs e)
        {
            SaveUndoData();
            DeleteSelectedItems();
        }

        private void mi_Context_DeleteExcept_Click(object sender, System.EventArgs e)
        {
            SaveUndoData();
            foreach(ListViewItem lvItem in lvSubtitles.Items)
            {
                if (lvItem.Selected == false)
                    lvItem.Remove();
            }
            RenumberAllSubtitles();  // also sets m_bDirty
        }

        private void LoadUndoData()
        {
            lvSubtitles.SuspendLayout();

            lvSubtitles.Items.Clear();
            foreach(object sub in alUndoData)
            {
                InsertSubtitleIntoList((Subtitle) sub);
            }

            lvSubtitles.ResumeLayout();
        }

        private void SaveUndoData()
        {
            alUndoData.Clear();
            alUndoData.Capacity = lvSubtitles.Items.Count;
            foreach(ListViewItem lvItem in lvSubtitles.Items)
            {
                alUndoData.Add(new Subtitle((Subtitle) lvItem.Tag));
            }
        }

        private void SaveRedoData()
        {
            alRedoData.Clear();
            alRedoData.Capacity = lvSubtitles.Items.Count;
            foreach(ListViewItem lvItem in lvSubtitles.Items)
            {
                alRedoData.Add(new Subtitle((Subtitle) lvItem.Tag));
            }
        }

        private void CopyRedoToUndo()
        {
            alUndoData.Clear();
            foreach(object ob in alRedoData)
                alUndoData.Add(new Subtitle((Subtitle) ob));
        }

        private void mi_Edit_Undo_Click(object sender, System.EventArgs e)
        {
            SaveRedoData();
            LoadUndoData();
            CopyRedoToUndo();
        }

        private void SubFutzerForm_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
        {
            switch(e.KeyCode)
            {
                case Keys.Delete:
                    if (lvSubtitles.Focused)
                    {
                        SaveUndoData();
                        DeleteSelectedItems();
                        e.Handled = true;
                    }
                    break;
                default:
                    break;
            }
        }

        private int MergeSubtitleIntoList(Subtitle sub)
        {
            int iFind = 0;
            Subtitle curSub;
            while (iFind < lvSubtitles.Items.Count)
            {
                curSub = (Subtitle) lvSubtitles.Items[iFind].Tag;
                if (curSub.StartTime >= sub.StopTime)
                {
                    // No overlap; just insert it into the list before this item
                    ListViewItem lvItem = new ListViewItem();
                    UpdateLVItem(lvItem, sub);
                    lvSubtitles.Items.Insert(iFind, lvItem);
                    return iFind;
                }
                if (curSub.StopTime > sub.StartTime)
                {
                    // This subtitle overlaps the previous one, so combine them and
                    // set the duration to the full overlap period.
                    curSub.Text = curSub.Text + "\r\n[ " + sub.Text + " ]";
                    if (curSub.StartTime > sub.StartTime)
                        curSub.StartTime = sub.StartTime;
                    if (sub.StopTime > curSub.StopTime)
                        curSub.StopTime = sub.StopTime;
                    UpdateLVItem(lvSubtitles.Items[iFind], curSub);
                    return iFind;
                }
                // Otherwise we haven't found the right spot yet
                iFind++;
            }
            // If we get here, the subtitle belongs at the end of the list
            return InsertSubtitleIntoList(sub);
        }

        public void MergeSubtitleFile(string sFileName)
        {
            SetReadyStatus();
            lvSubtitles.SuspendLayout();
            StreamReader reader = new StreamReader(sFileName, Encoding.Default);
            Subtitle sub;

            while (reader.Peek() != -1)
            {
                sub = ReadSubtitle(reader);
                if (sub.Valid)
                    MergeSubtitleIntoList(sub);
                UpdateProgress(reader.BaseStream.Position, reader.BaseStream.Length);
            }
            reader.Close();
            foreach(ColumnHeader ch in lvSubtitles.Columns)
            {
                ch.Width = -2;
            }

            lvSubtitles.ResumeLayout();
            RenumberAllSubtitles();
            m_bDirty = false;
            AddFileToMRU(sFileName);
            SetReadyStatus();
        }

        private void mi_File_Merge_Click(object sender, System.EventArgs e)
        {
            openFileDialog1.DefaultExt = "srt";
            openFileDialog1.Multiselect = false;
            openFileDialog1.Title = "Select subtitle file to merge";
            openFileDialog1.Filter = "SubRip files (*.srt)|*.srt|All files (*.*)|*.*";
            if (openFileDialog1.ShowDialog(this) != DialogResult.OK)
                return;

            SaveUndoData();
            MergeSubtitleFile(openFileDialog1.FileName);
        }

        private void tbMaxLength_TextChanged(object sender, System.EventArgs e)
        {
            try{ m_options.iLineLength = SafeConvertInt32(tbMaxLength.Text); }
            catch{ m_options.iLineLength = 50; }

        }

        private void mi_Help_About_Click(object sender, System.EventArgs e)
        {
            SFAboutBox aboutBox = new SFAboutBox();
			aboutBox.StartPosition = FormStartPosition.CenterParent;
			aboutBox.ShowDialog(this);
        }

        public void SetStatus(string sStatus)
        {
            statusBar1.Text = sStatus;
        }

        private void mi_File_New_Select(object sender, System.EventArgs e)
        {
            SetStatus("Clears the current subtitle list.");
        }

        private void mi_File_Open_Select(object sender, System.EventArgs e)
        {
            SetStatus("Loads an existing subtitle file.");
        }

        private void mi_File_Merge_Select(object sender, System.EventArgs e)
        {
            SetStatus("Merges an existing subtitle file with the current one.");
        }

        private void mi_File_Close_Select(object sender, System.EventArgs e)
        {
            SetStatus("Closes the current file.");
        }

        private void mi_File_Save_Select(object sender, System.EventArgs e)
        {
            SetStatus("Saves the current subtitle file.");
        }

        private void mi_File_SaveAs_Select(object sender, System.EventArgs e)
        {
            SetStatus("Saves the current subtitle file with a new name.");
        }

        private void mi_File_Exit_Select(object sender, System.EventArgs e)
        {
            SetStatus("Exit SubFutzer.");
        }

        private void mi_Edit_Undo_Select(object sender, System.EventArgs e)
        {
            SetStatus("Undo/Redo the previous action.");
        }

        private void mi_Edit_Options_Select(object sender, System.EventArgs e)
        {
            SetStatus("View or change the SubFutzer options.");
        }

        private void mi_Action_Renumber_Select(object sender, System.EventArgs e)
        {
            SetStatus("Re-indexes the current file from 1-N.");
        }

        private void mi_Action_ProcessJobs_Select(object sender, System.EventArgs e)
        {
            SetStatus("Selects a VirtualDub job file to process.");
        }

        private void mi_Action_ProcessDefault_Select(object sender, System.EventArgs e)
        {
            SetStatus("Process the VirtualDub job file (set via the Options page).");
        }

        private void mi_Help_About_Select(object sender, System.EventArgs e)
        {
            SetStatus("Display the \"About\" box.");
        }

        private void mi_File_Popup(object sender, System.EventArgs e)
        {
            SetReadyStatus();
        }

        private void mi_Edit_Popup(object sender, System.EventArgs e)
        {
            SetReadyStatus();
        }

        private void mi_Action_Popup(object sender, System.EventArgs e)
        {
            SetReadyStatus();
        }

        private void mi_Help_Popup(object sender, System.EventArgs e)
        {
            SetReadyStatus();
        }

        private void mi_Edit_Find_Click(object sender, System.EventArgs e)
        {
            DoFindDialog();
        }

        private void DoFindDialog()
        {
            if (dlgFindText.IsDisposed)
            {
                dlgFindText = new SFFindText();
                dlgFindText.SetMainForm(this);
                dlgFindText.CreateControl();
            }
            if ((dlgFindText.DesktopLocation.Y == 0) && (dlgFindText.DesktopLocation.X == 0))
            {
                Point pt = DesktopLocation;
                pt.Offset((Width / 2) - (dlgFindText.Width / 2), (Height / 2) - (dlgFindText.Height / 2));
                dlgFindText.DesktopLocation = pt;
            }
            if (lvSubtitles.SelectedItems.Count < 1)
                dlgFindText.iSearchIndex = 0;
            else
                dlgFindText.iSearchIndex = lvSubtitles.SelectedItems[0].Index;

            dlgFindText.Visible = true;
            dlgFindText.Activate();
        }

        private void mi_MRUFile_Click(object sender, System.EventArgs e)
        {
            SetReadyStatus();

            string sFile = (string) m_options.saMRUList[((MenuItem) sender).Index - m_MRUStart.Index - 1];
            if (File.Exists(sFile))
            {
                if (!CanClearCurrentFile())
                    return;

                SaveUndoData();
                ClearCurrentFile();
                ReadSubtitleFile(sFile);
            } 
            else
            {
                SetStatus("Warning: File does not exist - " + sFile);
            }
        }

        private void CreateMRUList()
        {
            if (m_options.saMRUList.Count > 0)
            {
                int iIndex = 0;

                if (m_MRUStart == null)
                {
                    m_MRUStart = miMRUSeparator.CloneMenu();
                    mi_File.MenuItems.Add(miMRUSeparator.Index, m_MRUStart);
                } 
                else
                {
                    iIndex = m_MRUStart.Index + 1;
                    while (miMRUSeparator.Index > iIndex)
                    {
                        mi_File.MenuItems.RemoveAt(iIndex);
                    }
                }

                MenuItem miMRU;
                iIndex = 1;
                while (iIndex < m_options.saMRUList.Count+1)
                {
                    miMRU = new MenuItem("&" + iIndex.ToString() + " " + m_options.saMRUList[iIndex-1], new System.EventHandler(mi_MRUFile_Click));
                    mi_File.MenuItems.Add(miMRUSeparator.Index, miMRU);
                    iIndex++;
                }
            } 
        }

        private void AddFileToMRU(string sFile)
        {
            if (m_options.saMRUList.Contains(sFile))
                return;

            if (m_options.saMRUList.Count == 0)
            {
                m_options.saMRUList.Add(sFile);
                CreateMRUList();
                return;
            }

            if ((m_options.saMRUList.Count < 9) && (m_options.saMRUList.Count > 0))
                m_options.saMRUList.Add(m_options.saMRUList[m_options.saMRUList.Count - 1]);

            for (int iIndex = m_options.saMRUList.Count - 1; iIndex > 0; iIndex--)
            {
                if (iIndex > 8)
                    continue;

                m_options.saMRUList[iIndex] = m_options.saMRUList[iIndex-1];
            }
            m_options.saMRUList[0] = sFile;
            CreateMRUList();
        }

        private void mi_File_Exit_Click(object sender, System.EventArgs e)
        {
            Close();
        }

        private void mi_Edit_FindAgain_Click(object sender, System.EventArgs e)
        {
            if (dlgFindText.IsDisposed)
            {
                DoFindDialog();
                return;
            }

            if (dlgFindText.GetSearchText() == "")
            {
                DoFindDialog();
                return;
            }

            dlgFindText.FindNext();
        }

        private void mi_Action_Collapse_Click(object sender, System.EventArgs e)
        {
            SaveUndoData();

            int iIndex = 0;
			bool bRenumber = false;
            while (iIndex < lvSubtitles.Items.Count - 1)
            {
                UpdateProgress(iIndex, lvSubtitles.Items.Count);
                if (!MergeDuplicates(iIndex, false))
					iIndex++;
				else
					bRenumber = true;
            }

			if (bRenumber)
				RenumberAllSubtitles();  // also sets m_bDirty

			SetReadyStatus();
        }

        private bool MergeDuplicates(int iStartIndex, bool bRenumberWhenFinished)
        {
            if (iStartIndex > lvSubtitles.Items.Count - 2)
                return false;

            bool bRenumber = false;

            do
            {
                Subtitle sub1 = (Subtitle) lvSubtitles.Items[iStartIndex].Tag;
                Subtitle sub2 = (Subtitle) lvSubtitles.Items[iStartIndex+1].Tag;

                // Never merge if subtitles are too far apart
                if (sub1.StopTime + new TimeSpan(0,0,0,0,100) < sub2.StartTime)
                    break;

                if (sub1.Text != sub2.Text)
                    break;

                sub1.StopTime = sub2.StopTime;
                lvSubtitles.Items[iStartIndex+1].Remove();
                bRenumber = true;
            }
            while (iStartIndex < lvSubtitles.Items.Count - 1);

            if (bRenumber && bRenumberWhenFinished)
                RenumberAllSubtitles();  // also sets m_bDirty

			return bRenumber;
        }

        private void mi_Edit_Next_Click(object sender, System.EventArgs e)
        {
            MoveNext();
        }

        private void mi_Edit_Previous_Click(object sender, System.EventArgs e)
        {
            MovePrevious();
        }

        private void MoveNext()
        {
            if (lvSubtitles.SelectedItems.Count < 1)
            {
                if (lvSubtitles.Items.Count > 0)
                {
                    lvSubtitles.Items[0].Selected = true;
                }
            }

            ListViewItem lviSel = lvSubtitles.SelectedItems[lvSubtitles.SelectedItems.Count - 1];
            int iNext = lviSel.Index + 1;
            if (iNext >= lvSubtitles.Items.Count)
                return;

            lvSubtitles.SelectedItems.Clear();
            lvSubtitles.Items[iNext].Selected = true;

            lvSubtitles.EnsureVisible(iNext);
        }

        private void MovePrevious()
        {
            if (lvSubtitles.SelectedItems.Count < 1)
            {
                if (lvSubtitles.Items.Count > 0)
                {
                    lvSubtitles.Items[0].Selected = true;
                }
            }

            ListViewItem lviSel = lvSubtitles.SelectedItems[0];
            int iPrev = lviSel.Index - 1;
            if (iPrev < 0)
                return;

            lvSubtitles.SelectedItems.Clear();
            lvSubtitles.Items[iPrev].Selected = true;

            lvSubtitles.EnsureVisible(iPrev);
        }

        private void mi_Context_Merge_Click(object sender, System.EventArgs e)
        {
            SaveUndoData();
            MergeSelectedItemsToSingle();
        }

        private void MergeSelectedItemsToSingle()
        {
            if (lvSubtitles.SelectedItems.Count < 2)
                return;

            // Set the start time of all selected items to the start time of the first item,
            // and the end time of the first item to the end time of the last item.
            Subtitle subFirst = (Subtitle) lvSubtitles.SelectedItems[0].Tag;
            Subtitle subLast = (Subtitle) lvSubtitles.SelectedItems[lvSubtitles.SelectedItems.Count - 1].Tag;

            subFirst.StopTime = subLast.StopTime;
            UpdateLVItem(lvSubtitles.SelectedItems[0], subFirst);

            while (lvSubtitles.SelectedItems.Count > 1)
            {
                Subtitle sub = (Subtitle) lvSubtitles.SelectedItems[1].Tag;
                if (sub.Text != subFirst.Text)
                    MergeSubtitleIntoList(sub);
                lvSubtitles.SelectedItems[1].Remove();
            }

            RenumberAllSubtitles();
        }

		private int SafeConvertInt32(string sValue)
		{
			try
			{
				return Convert.ToInt32(sValue);
			}
			catch(Exception)
			{
				return 0;
			}
		}

		private void SubFutzerForm_Load(object sender, System.EventArgs e)
		{
			this.Text = this.Text.Replace("[version]", Global.GetVersion());
		}

        private void mi_Context_Insert_Click(object sender, System.EventArgs e)
        {
            int iIndex = 0;
            if (lvSubtitles.SelectedItems.Count < 1)
                iIndex = lvSubtitles.Items.Count;
            else
                iIndex = lvSubtitles.SelectedItems[0].Index;

            Subtitle sub = new Subtitle();

            if (iIndex > 0)
            {
                Subtitle subCopy = (Subtitle) lvSubtitles.Items[iIndex - 1].Tag;
                sub.StartTime = subCopy.StopTime;
            }

            sub.StopTime = sub.StartTime.AddSeconds(2);
            
            ListViewItem lvItem = new ListViewItem();
            UpdateLVItem(lvItem, sub);

            lvSubtitles.Items.Insert(iIndex, lvItem);

            RenumberAllSubtitles();

            m_bDirty = true;
        }

        private void mi_Action_SubDown_Click(object sender, System.EventArgs e)
        {
            RealignSubs(1);
        }

        private void mi_Action_SubUp_Click(object sender, System.EventArgs e)
        {
            RealignSubs(-1);
        }

        private void RealignSubs(int iOffset)
        {
            LVICollection items = new LVICollection(lvSubtitles.Items);
            if (!ProcessAllItems())
            {
                items = new LVICollection(lvSubtitles.SelectedItems);
            }

            int iMax = Math.Abs(iOffset);
            int iStart = 0;
            int iEnd = items.Count - iMax;
            int iSign = Math.Sign(iOffset);

            if (iMax == iOffset) // i.e. if it's positive
            {
                iStart = items.Count - 1;
                iEnd = iMax - 1;
            }

            for (int i = iStart; i != iEnd; i -= iSign)
            {
                Subtitle sub1 = (Subtitle) items[i].Tag;
                Subtitle sub2 = (Subtitle) items[i - iOffset].Tag;

                sub1.Text = sub2.Text;

                UpdateLVItem(items[i], sub1);
                UpdateLVItem(items[i - iOffset], sub2);
            }

            m_bDirty = true;
        }

		private void mi_Action_RemoveIntra_Click(object sender, System.EventArgs e)
		{
			char[] charBeginning = {'[', ' ', '\r', '\n'};
			char[] charEnding = {']', ' ', '\r', '\n'};

			SaveUndoData();

			for (int iIndex = 0; iIndex < lvSubtitles.Items.Count; iIndex++)
			{
				UpdateProgress(iIndex, lvSubtitles.Items.Count);
				Subtitle sub = (Subtitle) lvSubtitles.Items[iIndex].Tag;

				// Check to see if any lines in this subtitle are identical, ignoring
				// any surrounding brackets.
				ArrayList arrayLines = new ArrayList();
				int iOldFind = 0;
				int iFind = 0;
				while (iFind >= 0)
				{
					iFind = sub.Text.IndexOfAny(new char[] {'\r', '\n'}, iFind+1);
					if (iFind < 0)
						break;
					if (iFind + 1 >= sub.Text.Length)
						break;
					if (IsCRLF(sub.Text[iFind+1]))
						continue;
					arrayLines.Add(sub.Text.Substring(iOldFind, iFind - iOldFind).Trim());
					iOldFind = iFind;
				}
				arrayLines.Add(sub.Text.Substring(iOldFind));

				for(int iLine = 0; iLine < arrayLines.Count - 1; iLine++)
				{
					for (int iCompare = iLine + 1; iCompare < arrayLines.Count; iCompare++)
					{
						string sLine = (string) arrayLines[iLine];
						string sCompare = (string) arrayLines[iCompare];
						int iBegin = 0;
						while (IsOneOf(sLine[iBegin], charBeginning))
							iBegin++;
						int iEnd = sLine.Length;
						while (IsOneOf(sLine[iEnd-1], charEnding))
						{
							iEnd--;
							if (iEnd <= iBegin + 1)
								break;
						}
						sLine = sLine.Substring(iBegin, iEnd - iBegin);

						iBegin = 0;
						while (IsOneOf(sCompare[iBegin], charBeginning))
							iBegin++;
						iEnd = sCompare.Length;
						while (IsOneOf(sCompare[iEnd-1], charEnding))
						{
							iEnd--;
							if (iEnd <= iBegin + 1)
								break;
						}
						sCompare = sCompare.Substring(iBegin, iEnd - iBegin);

						if (sLine == sCompare)
							arrayLines.RemoveAt(iCompare);
					}
				}

				sub.Text = "";
				for(int iLine = 0; iLine < arrayLines.Count; iLine++)
				{
					sub.Text += ((string) arrayLines[iLine]).Trim();
					if (iLine < arrayLines.Count - 1)
						sub.Text += "\r\n";
				}

				UpdateLVItem(lvSubtitles.Items[iIndex], sub);

			}
		}

		private void mi_Action_RemoveShort_Click(object sender, System.EventArgs e)
		{
			RemoveShortForm form = new RemoveShortForm();
			form.StartPosition = FormStartPosition.CenterParent;
			if (form.ShowDialog() != DialogResult.Cancel)
			{
				lvSubtitles.SuspendLayout();
				int iDuration = form.Duration;
				int iIndex = 0;
				bool bRenumber = false;
				while (iIndex < lvSubtitles.Items.Count)
				{
					UpdateProgress(iIndex, lvSubtitles.Items.Count);

					if (((Subtitle) lvSubtitles.Items[iIndex].Tag).Duration.TotalMilliseconds < iDuration)
					{
						lvSubtitles.Items[iIndex].Remove();
						bRenumber = true;
					}
					else
						iIndex++;
				}

				if (bRenumber)
					RenumberAllSubtitles();
				lvSubtitles.ResumeLayout();
			}
		}

		private void mi_Edit_GoTo_Click(object sender, System.EventArgs e)
		{
			GoToLineForm form = new GoToLineForm();
			form.StartPosition = FormStartPosition.CenterParent;
			if (form.ShowDialog() != DialogResult.Cancel)
			{
				int iIndex = form.Index;
				if ((iIndex < lvSubtitles.Items.Count) && (iIndex >= 0))
					lvSubtitles.EnsureVisible(iIndex);
			}
		}

		private int SafeConvertInt32(string sValue, int iBase)
		{
			try
			{
				return Convert.ToInt32(sValue, iBase);
			}
			catch(Exception)
			{
				return 0;
			}
		}

		/*
        protected override bool ProcessDialogKey(Keys keyData)
        {
            if ((keyData & Keys.Control) == Keys.Control)
            {
                Keys key = keyData & ~Keys.Modifiers;
                switch(key)
                {
                    case Keys.Up:
                        MovePrevious();
                        return true;
                    case Keys.Down:
                        MoveNext();
                        return true;
                }
            }
            return false;
        }
*/
	}
}
